
#include <qcheckbox.h>

#include <gui/checkbox.h>
#include <util/message.h>

enum { ID_SELECTED };

class QCheckBoxWidget : public os::CheckBox
{
public:
	QCheckBoxWidget( os::Rect cFrame, os::String zName, os::String zLabel, os::Message* pcMsg, uint32 nResizeFlags )
		: os::CheckBox( cFrame, zName, zLabel, pcMsg, nResizeFlags )
	{
	}
	virtual void  MouseMove( const os::Point& cNewPos, int nCode, uint32 nButtons, os::Message* pcData )
	{
		//os::CheckBox::MouseMove( cNewPos, nCode, nButtons, pcData );
		os::View::MouseMove( cNewPos, nCode, nButtons, pcData );
	}
    virtual void  MouseDown( const os::Point& cPosition, uint32 nButtons )
    {
    	//os::CheckBox::MouseDown( cPosition, nButtons );
    	os::View::MouseDown( cPosition, nButtons );    	
    }
    virtual void  MouseUp( const os::Point& cPosition, uint32 nButtons, os::Message* pcData )
    {
    	//os::CheckBox::MouseUp( cPosition, nButtons, pcData );
    	os::View::MouseUp( cPosition, nButtons, pcData );
    }
};

class QCheckBox::Private
{
public:
    os::CheckBox* m_pcCheckBox;
};

QCheckBox::QCheckBox( QWidget* pcParent, const char* pzName ) : QWidget( pcParent, pzName )
{
    d = new Private;
    d->m_pcCheckBox = new QCheckBoxWidget( GetBounds(), "radiobutton", "", new os::Message( ID_SELECTED ), os::CF_FOLLOW_ALL );

    AddChild( d->m_pcCheckBox );
    d->m_pcCheckBox->SetTarget( this );
}

QCheckBox::~QCheckBox()
{
	delete d;
}

bool QCheckBox::isChecked() const
{
    return( d->m_pcCheckBox->GetValue() );
}

void QCheckBox::setChecked( bool check )
{
    d->m_pcCheckBox->SetValue( check, false );
    emit stateChanged( (d->m_pcCheckBox->GetValue()) ? 2 : 0 );
}

QSize QCheckBox::sizeHint() const
{
    os::Point cSize = d->m_pcCheckBox->GetPreferredSize( false );
    return( QSize( int(cSize.x), int(cSize.y) ) );
}


void QCheckBox::HandleMessage( os::Message* pcMessage )
{
    switch( pcMessage->GetCode() )
    {
	case ID_SELECTED:
	    emit clicked();
	    emit stateChanged( (d->m_pcCheckBox->GetValue()) ? 2 : 0 );
	    break;
	default:
	    QWidget::HandleMessage( pcMessage );
	    break;
    }
}

#include "qcheckbox.moc"





