/****************************************************************************
** $Id$
**
** Implementation of QDesktopWidget class.
**
** Created :
**
** Copyright (C) 1992-2001 Trolltech AS.  All rights reserved.
**
** This file is part of the kernel module of the Qt GUI Toolkit.
**
** This file may be distributed under the terms of the Q Public License
** as defined by Trolltech AS of Norway and appearing in the file
** LICENSE.QPL included in the packaging of this file.
**
** This file may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.
**
** Licensees holding valid Qt Enterprise Edition or Qt Professional Edition
** licenses for Unix/X11 may use this file in accordance with the Qt Commercial
** License Agreement provided with the Software.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
**   information about Qt Commercial License Agreements.
** See http://www.trolltech.com/qpl/ for QPL licensing information.
** See http://www.trolltech.com/gpl/ for GPL licensing information.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.
**
**********************************************************************/

#include "qdesktopwidget.h"
#include <gui/desktop.h>

QDesktopWidget::QDesktopWidget()
: QWidget( 0, "desktop" )
{
}

QDesktopWidget::~QDesktopWidget()
{
    
}

bool QDesktopWidget::isVirtualDesktop() const
{
    return( false );
}

int QDesktopWidget::primaryScreen() const
{
    return 0;
}

int QDesktopWidget::numScreens() const
{
    return 1;
}

QWidget *QDesktopWidget::screen( int /*screen*/ )
{
    return( this );
}

const QRect QDesktopWidget::screenGeometry( int/* screen*/ ) const
{
	os::Desktop cDesktop;
	os::IPoint cSize = cDesktop.GetResolution();
	return( QRect( 0, 0, (int)cSize.x, (int)cSize.y ) );
    
}

QRect QDesktopWidget::rect()
{
	return( screenGeometry() );
}

int QDesktopWidget::screenNumber( QWidget */*widget*/ ) const
{
    return( 0 );
}

int QDesktopWidget::screenNumber( const QPoint &/*point*/ ) const
{
	return( 0 );
}

#include "qdesktopwidget.moc"
