#include <gui/font.h>
#include <stdio.h>

#include "qfontdatabase.h"

QFontDatabase::QFontDatabase()
{
	m_sizes.push_back( 10 );
	m_sizes.push_back( 12 );
	m_sizes.push_back( 14 );
	m_sizes.push_back( 16 );
	m_sizes.push_back( 20 );
	m_sizes.push_back( 24 );
	m_sizes.push_back( 28 );
	m_sizes.push_back( 32 );
	m_sizes.push_back( 48 );
	m_sizes.push_back( 72 );
}

QString QFontDatabase::styleString( const QFont &)
{
    return( m_style );
}

bool QFontDatabase::isSmoothlyScalable( const QString &family,
					const QString &/*style*/ ,
					const QString &/*charSet*/  ) const
{
	char zStyleName[FONT_STYLE_LENGTH];
	uint32 nFlags;
	for( int i = 0; i < os::Font::GetStyleCount( family.ascii() ); ++ i )
	{
		uint32 nFlags;
		if( os::Font::GetStyleInfo( family.ascii(), i, zStyleName, &nFlags ) == 0 )
		{
			if( !strcmp( zStyleName, "Regular" ) || !strcmp( zStyleName, "Roman" ) )
			{
//				printf("FONT FOUND %s %x!\n", family.ascii(), nFlags);
				if( nFlags & os::FONT_IS_SCALABLE )
					return( true );
			}
		}
	}
//    if ( style == charSet) return( true ); return( true );
	return( false );
}

QValueList<int> QFontDatabase::smoothSizes( const QString &/*family*/,
					    const QString &style,
					    const QString &charSet )
{
    if ( style == charSet) return( m_sizes ); return( m_sizes );
}

QStringList QFontDatabase::families()
{
	QStringList cList;
	char zTemp[FONT_FAMILY_LENGTH];
	for( int i = 0; i < os::Font::GetFamilyCount(); i++ )
	{
		if( os::Font::GetFamilyInfo( i, zTemp ) == 0 )
			cList.append( zTemp );
	}
	return( cList );
}














