#ifndef _QFONTMETRICS_H_
#define _QFONTMETRICS_H_


#include <qrect.h>
#include <qstring.h>

class QFont;
class QString;

namespace os
{
    class Font;
}

class QFontMetricsInternal;

class QFontMetrics
{
public:
    QFontMetrics();
    QFontMetrics( const QFont& );
    QFontMetrics( const QFontMetrics & );
    ~QFontMetrics();
    QFontMetrics& operator=( const QFontMetrics& cOther);
    
    void setFont( const QFont& );
    int height() const;
    int width( const QString &, int len = -1 ) const;
    int width( QChar ) const;
    int width( char c ) const;
    int charWidth( const QString &, int pos ) const;
    QSize	size( int flags,
		      const QString& str );

    int ascent() const;
    int descent() const;
    int lineSpacing()	const;
    int leading()	const;
    int lineWidth() const;
    
    bool inFont( int c );
    
    int rightBearing(QChar) const;
    
    QRect boundingRect( int x, int y, int w, int h, int flags,
			      const QString& cStr ) const;
    QRect boundingRect( const QString &, int len = -1 ) const;
    QRect boundingRect( QChar ) const;
private:
	friend class QWidget;
    friend class QPainter;
    QFontMetrics( os::Font* pcFont );
    QFontMetricsInternal* d;
};

#endif













