#ifndef __F_ALINEEDIT_H__
#define __F_ALINEEDIT_H__


#include <qwidget.h>
#include <qstringlist.h>


class QLineEdit : public QWidget
{
    Q_OBJECT
public:
    enum	EchoMode { Normal, NoEcho, Password };
    QLineEdit( QWidget* pcParent, const char* pzName = NULL );
    QLineEdit( QWidget* pcParent );
    ~QLineEdit();

    virtual void AllAttached();
    virtual void HandleMessage( os::Message* pcMessage );
    
    void   SetMinPreferredSize( int nWidthChars );
    virtual QSize sizeHint() const;

	int maxLength() const;
    virtual void setMaxLength( int );
    
    QString text() const;
    void 	setText( const QString &);
    bool	frame() const;
    
    void insert( const QString& );
    
	void setSelection( int pos, int length );
    void	selectAll();
    
    void setDragEnabled( bool );
    
    void setAlignment( AlignmentFlags );
    
    void setReadOnly( bool );
    bool isReadOnly() const;
    
    void setEdited( bool );
    bool edited() const;
    
    virtual void setCursorPosition( int );
    int cursorPosition() const;
    
    virtual void setEchoMode( EchoMode );

signals:
    void returnPressed();
    void textChanged( const QString & );
    
private:
    class Private;
    Private* d;
    
};

#endif // __F_ALINEEDIT_H__





